<?php

namespace Goldenscarab\Modulus\Debusca\App\Http\Drivers;

use Illuminate\Support\Collection;
use Goldenscarab\Modulus\Debusca\App\Http\Drivers\Objects\QueryResult;

abstract class Driver
{
    protected $db;

    public function __construct($db)
    {
        $this->db = $db;
    }

    public abstract function getTables(): Collection;

    public abstract function getMetas($table): Collection;

    public abstract function getSuggestions(): Collection;

    public abstract function query($query): QueryResult;

    public abstract function getQueryString($query);
}
