<?php

namespace Goldenscarab\Modulus\Debusca\App\Http\Drivers\Objects;

use Exception;
use Illuminate\Support\Collection;


class MetaCollect extends Collection
{

    public function getFieldsNamesString()
    {
        return $this->pluck('field')->map(function($item) {
            return sprintf('`%s`', $item);
        })->implode(', ');
    }

    public function getFieldsNamesArray()
    {
        return $this->pluck('field')->values()->toArray();
    }

    public function getFieldsDefaultArray()
    {
        return $this->pluck('default')->values()->toArray();
    }

    public function getTableName()
    {
        return $this->first()->getTable();
    }

    public function getTableAlias()
    {
        $alias = '';
        $splited = explode('_', $this->getTableName());

        foreach ($splited as $part) {
            $alias .= substr($part, 0, 1);
        }

        return strtolower($alias);
    }

    public function getPKName()
    {
        $meta_pk = $this->where('key', 'primary_key')->first();
        if (is_null($meta_pk)) {
            return null;
        }
        return $meta_pk->getField();
    }

}
